# 贡献规范

大家可以通过提交问题、建议和PR来为项目做出贡献，提交地址：[Issues](https://gitee.com/acgist/snail/issues)

提交前请大家阅读本贡献规范

谢谢！

## 目录

* [注意事项](#注意事项)
* [提交问题](#提交问题)
	* [提交问题准备](#提交问题准备)
	* [提交问题规范](#提交问题规范)
* [提交建议](#提交建议)
	* [提交建议准备](#提交建议准备)
	* [提交建议规范](#提交建议规范)
* [提交PR](#提交pr)
	* [提交PR规范](#提交pr规范)
	* [提交PR步骤](#提交pr步骤)

## 注意事项

* 禁止发表和项目无关信息（包含但不限于政治、广告）
* 禁止在讨论中发表粗口、人身攻击以及过激的言语
* 提交报告前请仔细检查是否包含你的隐私信息
* 提交内容可能不会被及时处理

## 提交问题

提交问题报告可以更好的帮助开发者发现修复软件存在的问题（BUG）

#### 提交问题准备

提交问题报告前，请先排除一些基本问题：

* 阅读[帮助](./HELP.md)是否已经提供解决方法
* 检查[Issues](https://gitee.com/acgist/snail/issues)是否已经提交过此问题
* 检查JDK、网络、路由、防火墙配置（排除环境因素）
* 检查运行系统和JavaFX依赖系统是否一致

#### 提交问题规范

请使用模板提交Issue，方便开发者清晰理解你的问题：

* 标签：必须打上标签：问题
* 标题：[问题]简单描述（例：**[问题]磁力链接下载失败**）
* 系统环境：系统信息、软件信息
* 详细描述：详细描述问题
* 重现步骤：问题重现步骤
* 其他信息：系统日志（logs目录）、错误截图、配置截图

## 提交建议

提交建议可以更好的帮助开发者优化软件使用

#### 提交建议准备

* 检查[Issues](https://gitee.com/acgist/snail/issues)是否已经提交过此建议

#### 提交建议规范

请使用模板提交Issue，方便开发者清晰理解你的建议：

* 标签：必须打上标签：建议
* 标题：[建议]简单描述（例：**[建议]添加磁力链接支持**）
* 系统环境：系统信息、软件信息
* 详细描述：详细描述建议及其带来的效果

## 提交PR

提交PR可以修复问题或者提交功能增强

#### 提交PR规范

请使用模板提交PR，方便开发者清晰理解你的PR：

* 类型：必须选择PR类型：修复BUG、功能增强
* 关联Issue（选填）：如果PR有关联的Issue必须关联Issue
* 详细描述：详细描述PR修改的内容
* 测试用例（选填）：测试用例
* 提交PR前请阅读[代码规范](./CODE_OF_CONDUCT.md)

#### 提交PR步骤

* 将项目fork到自己的项目下（不要直接在仓库下新建分支）
* 提交PR前先rebase（确保commit记录整洁）
* 将PR提交到对应pr分支（不要提交到master分支）
